<?php

namespace Drupal\activitypub\Controller;

use Drupal\activitypub\Entity\ActivityPubActorInterface;
use Drupal\Core\Access\AccessResult;
use Drupal\Core\Controller\ControllerBase;
use Drupal\user\UserInterface;

class BaseController extends ControllerBase {

  /**
   * Check that the actor points to the user.
   *
   * @param \Drupal\user\UserInterface $user
   *
   * @param \Drupal\activitypub\Entity\ActivityPubActorInterface $activitypub_actor
   *
   * @return \Drupal\Core\Access\AccessResultInterface
   *   The access result.
   */
  public function actorUserCheck(UserInterface $user, ActivityPubActorInterface $activitypub_actor) {

    if ($user->id() == $activitypub_actor->getTargetEntityId()) {
      return AccessResult::allowed();
    }

    return AccessResult::forbidden();
  }

}
