<?php

namespace Drupal\activitypub\Entity;

use Drupal\Core\Access\AccessResult;
use Drupal\Core\Entity\EntityAccessControlHandler;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Session\AccountInterface;

/**
 * Access control handler for the activitypub activity entity.
 */
class ActivityPubActivityAccessControlHandler extends EntityAccessControlHandler {

  /**
   * {@inheritdoc}
   */
  protected function checkAccess(EntityInterface $entity, $operation, AccountInterface $account) {

    /** @var \Drupal\indieweb_webmention\Entity\WebmentionInterface $entity */
    switch ($operation) {
      case 'view':
        return AccessResult::allowed();

      case 'queue':
      case 'update':
      case 'delete':
        return AccessResult::allowedIf($account->id() == $entity->getOwnerId());
    }

    // Unknown operation, just forbid.
    return AccessResult::forbidden();
  }

}
